# -*- coding: utf-8 -*-

"""
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

Author    : Jagadees.s
            msgjsp@gmail.com 
            jagadees.wordpress.com 

Copyright (C) 2014  Jagadees.s. 

"""
import sys
import os.path
import copy
import urllib2
try:
    from PyQt4 import QtGui, QtCore
    from PyQt4.QtCore import *
    from PyQt4.QtGui import *
    from PyQt4.QtSql import *
except ImportError:
	print "Error: PyQt4 required"
    
DB_NAME = "dbJNotes"
DB_BKP_NAME = ".dbJNotes"
SRC_PATH = ""

class MainWindow(QtGui.QMainWindow):
    def __init__(self):
        QtGui.QMainWindow.__init__(self)
        self.resize(350, 250)
        self.setWindowTitle('mainwindow')
        
        # widgets
        dockWidget = QtGui.QDockWidget("Tags", self)
        dockWidget2 = QtGui.QDockWidget("Note Item", self)
        self.editor = QtGui.QTextEdit()
        self.lstTags = QtGui.QListWidget()
        self.lstDataItems = QtGui.QListWidget()

        # data structures
        self.NoteMap = {}
        self.bNew = False
        self.bEdit = False
        
        actExit = QtGui.QAction(QtGui.QIcon(SRC_PATH + '/icons/application-exit.png'), 'Exit', self)
        actExit.setShortcut('Ctrl+Q')
        actExit.setStatusTip('Exit application')
        #self.connect(actExit, QtCore.SIGNAL('triggered()'), QtCore.SLOT('close()'))
        self.connect(actExit, QtCore.SIGNAL('triggered()'), self.OnClose)
        
        actNewNote = QtGui.QAction(QtGui.QIcon(SRC_PATH + '/icons/document-new.png'), 'NewNote', self)
        actNewNote.setStatusTip('New Note')
        self.connect(actNewNote, QtCore.SIGNAL('triggered()'), self.OnNewNote)
        
        actEditNote = QtGui.QAction(QtGui.QIcon(SRC_PATH + '/icons/edit-select-all.png'), 'EditNote', self)
        actEditNote.setStatusTip('Edit Note')
        self.connect(actEditNote, QtCore.SIGNAL('triggered()'), self.OnEditNote)
        
        self.actSaveNote = QtGui.QAction(QtGui.QIcon(SRC_PATH + '/icons/document-save.png'), 'SaveNote', self)
        self.actSaveNote.setStatusTip('Save')
        self.actSaveNote.setDisabled(True)
        self.connect(self.actSaveNote, QtCore.SIGNAL('triggered()'), self.OnSaveNote)
        
        self.statusBar()
        
        menubar = self.menuBar()
        file = menubar.addMenu('&File')
        file.addAction(actExit)
        mNotes = menubar.addMenu('&Notes')
        mTags = menubar.addMenu('&Tags')
        mTools = menubar.addMenu('Too&ls')
        mHelp = menubar.addMenu('&Help')
        
        #actNewNote = QtGui.QAction('New', self)
        #actEditNote = QtGui.QAction('Edit', self)
        #actSaveNote = QtGui.QAction('Edit', self)
        actDelNote = QtGui.QAction('Delete', self)
        self.connect(actDelNote, QtCore.SIGNAL('triggered()'), self.OnDeleteNote)
        mNotes.addAction(actNewNote)
        mNotes.addAction(actEditNote)
        mNotes.addAction(self.actSaveNote)
        mNotes.addAction(actDelNote)
        
        actAddTag = QtGui.QAction('Add &Tag', self)
        actAddTag.setShortcut('Ctrl+T')
        actAddTag.setStatusTip('Add a tag')
        self.connect(actAddTag, QtCore.SIGNAL('triggered()'), self.OnAddTag)
        actEditTag = QtGui.QAction('&Edit Tag', self)
        actDelTag = QtGui.QAction('&Delete Tag', self)
        self.connect(actDelTag, QtCore.SIGNAL('triggered()'), self.OnDeleteTag)
        mTags.addAction(actAddTag)
        mTags.addAction(actEditTag)
        mTags.addAction(actDelTag)
        
        actImport = QtGui.QAction('Import', self)
        actExport = QtGui.QAction('Export', self)
        mTools.addAction(actImport)
        mTools.addAction(actExport)
        mDB = mTools.addMenu('DB')
        actCrDB = QtGui.QAction('Create DB', self)
        actSlDB = QtGui.QAction('Select DB', self)
        actBrDB = QtGui.QAction('Browse DB', self)
        mDB.addAction(actCrDB)
        mDB.addAction(actSlDB)
        mDB.addAction(actBrDB)
        
        actAbout = QtGui.QAction('&About', self)
        self.connect(actAbout, QtCore.SIGNAL('triggered()'), self.OnAbout)
        mHelp.addAction(actAbout)
        
        toolbar = self.addToolBar('File')
        toolbar.setObjectName("FileToolBar")
        #toolbar.addActions((actNewNote, actEditNote, self.actSaveNote))
        toolbar.addActions((actNewNote, self.actSaveNote))
        toolbar.addSeparator()
        toolbar.addAction(actExit)
        #toolbar.addAction(actNewNote)
        #toolbar = self.addToolBar('Edit Note')
        #toolbar.addAction(actEditNote)        
        #toolbar = self.addToolBar('Save Note')
        #toolbar.addAction(actSaveNote)
        #toolbar = self.addToolBar('Exit')
        #toolbar.addAction(exit)

        toolbar.show()

        self.lstTags.setResizeMode(QListView.Adjust)
        self.lstTags.setViewMode(QListView.IconMode)
        self.lstTags.setFlow(QListView.LeftToRight)
        #self.lstTags.setSelectionMode(QAbstractItemView.MultiSelection)
        self.lstTags.setSelectionMode(QAbstractItemView.ExtendedSelection)
        self.addDockWidget(Qt.TopDockWidgetArea,dockWidget)
        dockWidget.setWidget(self.lstTags)
        self.connect(self.lstTags, SIGNAL("itemSelectionChanged()"), self.OnTagSelChanged)
        #self.connect(self.lstTags, SIGNAL("currentItemChanged(QListWidgetItem*, QListWidgetItem*)"), self.TagCurrItemChanged)
        #self.connect(self.lstTags, SIGNAL("clicked()"), self.OnTagsListClicked)

        self.addDockWidget(0x1,dockWidget2)
        #self.lstDataItems.setSelectionMode(QAbstractItemView.MultiSelection)
        dockWidget2.setWidget(self.lstDataItems)
        self.connect(self.lstDataItems, SIGNAL("currentItemChanged(QListWidgetItem*, QListWidgetItem*)"), self.OnNoteCurrItemChanged)

        self.editor.setReadOnly(True)

        self.setCentralWidget(self.editor)
        
    def OnDeleteTag(self):
        print "OnDeleteTag"
        query1 = QSqlQuery()
        tags = self.lstTags.selectedItems()
        for t in tags:
            print t.text()
            nTagId = t.data(Qt.UserRole).toInt()
            print nTagId
            bRet = query1.exec_("select count(*) from tblNoteType where idTag = '%s'" % nTagId[0])
            query1.next()
            if 0 == query1.value(0).toInt()[0]:
                bRet = query1.exec_("delete from tblNoteType where idTag='%s'" % nTagId[0])
                bRet = query1.exec_("delete from tblTags where id='%s'" % nTagId[0])
                self.lstTags.takeItem(self.lstTags.indexFromItem(t).row())
            else:
                QMessageBox.warning(None, "JNoteBook", QString("Tag %1 contains notes. Please delete them first.").arg(t.text()))
                continue
        
    def OnDeleteNote(self):
        print "OnDeleteNote"
        nNoteId = self.lstDataItems.currentItem().data(Qt.UserRole).toInt()
        query1 = QSqlQuery()
        bRet = query1.exec_("delete from tblNoteType where idNote='%s'" % nNoteId[0])
        #print "delete from tblNoteType where idNote='%s'" % nNoteId[0]
        bRet = query1.exec_("delete from tblNotes where id='%s'" % nNoteId[0])
        #print "delete from tblNotes where id='%s'" % nNoteId[0]
        self.lstDataItems.takeItem(self.lstDataItems.currentRow())
        self.editor.clear()
        
    def OnClose(self):
        #QFile.remove(DB_BKP_NAME)
        #QFile.copy(DB_NAME, DB_BKP_NAME)
        print "exit"
        sys.exit(1)
        
    def OnTagsListClicked(idx):
        print "clicked"
        print idx.toInt()[0]
        
    def Initialize(self):    
        if self.db.open():
           self.query = QSqlQuery()
           bRet = self.query.exec_("select * from tblTags order by tagName")
           i = 0
           while self.query.next():
               idTag = self.query.value(0).toInt()[0]
               tag = self.query.value(1).toString()#print id, tag
               item = QListWidgetItem()
               item.setText(tag)
               item.setData(Qt.UserRole, QVariant(idTag))
               self.lstTags.insertItem(i, item)
               i = i+1 
           self.lstTags.setFlow(QListView.LeftToRight)

    def Setup(self):
        self.db = QSqlDatabase.addDatabase("QSQLITE")
        self.db.setDatabaseName(DB_NAME)
        if not self.db.open():
            QMessageBox.warning(None, "JNoteBook", QString("Database Error: %1").arg(self.db.lastError().text()))
            sys.exit(1)
        query = QSqlQuery()
        bRet = self.db.exec_("""CREATE TABLE tblTags (tagName VARCHAR(40) NOT NULL)""")
        self.db.exec_("""CREATE VIRTUAL TABLE tblNotes USING FTS4 (Title, Note)""")
        self.db.exec_("""CREATE TABLE tblNoteType (idNote INTEGER NOT NULL, idTag INTEGER NOT NULL)""")

        #self.db.close()

    def OnNoteCurrItemChanged(self, newItem, oldItem):
        if (False == self.bNew):
            print "NoteCurrItemChanged"
            #print newItem.text()
            nNoteId = newItem.data(Qt.UserRole).toInt()
            #print "Note id: '%d'" % nNoteId
            print "Note id"
            print nNoteId
            query = QSqlQuery()
            #bRet = query.exec_("select Note from tblNotes where id='%s'" % nNoteId[0])
            bRet = query.exec_("select Note from tblNotes where rowid='%s'" % nNoteId[0])
            while query.next():
                Note = query.value(0).toString()
                self.editor.setText(Note)
        
    def OnTagSelChanged(self):
        if True == self.bNew or True == self.bEdit:
            return
        print "TagSelChanged"
        tags = self.lstTags.selectedItems()
        self.NoteMap = 0
        i = 0
        self.lstDataItems.clear()
        self.editor.clear()
        query = QSqlQuery()
        
        strSelect = "select distinct n.id, n.Title from tblNotes n inner join (select * from tblNoteType where "
        strTypeId = ""
        nTagCount = len(tags)
        for t in tags:
            print t.text()
            nTagId = t.data(Qt.UserRole).toInt()
            print nTagId
            #strSelect += "idTag = '%s' or "%nTagId[0]
            strTypeId += "'%s'," % nTagId[0]
        strTypeId = strTypeId[0:-1]
        print strTypeId
        
        strSelect = "SELECT distinct V.rowid, V.Title FROM tblNoteType B INNER JOIN tblNotes V ON B.idNote = V.rowid INNER JOIN tblTags T ON B.idTag = T.rowid WHERE V.rowid IN(SELECT V.rowid FROM tblNoteType B INNER JOIN tblNotes V ON B.idNote = V.rowid INNER JOIN tblTags T ON B.idTag = T.rowid WHERE T.rowid IN(%s) GROUP BY V.rowid HAVING COUNT(V.rowid) = %d) AND T.rowid IN(%s) ORDER BY V.Title, T.tagName" %(strTypeId, nTagCount, strTypeId) 
        
        #strSelect = "SELECT distinct V.id, V.Title FROM tblNoteType B INNER JOIN tblNotes V ON B.idNote = V.id INNER JOIN tblTags T ON B.idTag = T.id WHERE V.id IN(SELECT V.id FROM tblNoteType B INNER JOIN tblNotes V ON B.idNote = V.id INNER JOIN tblTags T ON B.idTag = T.id WHERE T.id IN(%s) GROUP BY V.id HAVING COUNT(V.id) = %d) AND T.id IN(%s) ORDER BY V.Title, T.tagName" %(strTypeId, nTagCount, strTypeId) 

        #print strSelect
        #bRet = query.exec_("select n.id, n.Title from tblNotes n inner join (select * from tblNoteType where idTag = '%i') t on n.id = t.idNote"%nTagId[0])
        #bRet = query.exec_(strSelect)

        bRet = query.exec_(strSelect)
        while query.next():
            nNoteId = query.value(0).toInt()[0]
            title = query.value(1).toString()
            item = QListWidgetItem()
            item.setText(title)
            item.setData(Qt.UserRole, QVariant(nNoteId))
            self.lstDataItems.insertItem(i, item)
            i = i+1

    def OnNewNote(self):
        print "New note clicked"
        if self.bEdit == False:
            self.bNew = True
            itemTag = self.lstDataItems.currentItem()
            if itemTag:
                itemTag.setSelected(False)
            self.editor.clear()
            self.editor.setReadOnly(False)
            self.actSaveNote.setEnabled(True)

    def OnEditNote(self):
        print "Edit note clicked"
        if self.bNew == False:
            self.bEdit = True
            self.editor.setReadOnly(False)
            self.actSaveNote.setEnabled(True)
        
    def OnSaveNote(self):
        print "Save note clicked"
        strNote = self.editor.toPlainText()
        strNote.replace("\"", "\"\"")
        #print strNote
        fstLine = strNote.left(strNote.indexOf("\n"))
        fstLine = fstLine.left(30)
        tags = self.lstTags.selectedItems()
        if len(tags)<= 0:
            QMessageBox.warning(None, "JNoteBook", "Please select at least one tag")
            return

        if self.db.open():
                rollback = False
            #try:
                query = QSqlQuery()
                nNoteId = 0
                self.db.transaction()
                bRet = False
                if True == self.bNew:
                    bRet = query.exec_("""INSERT INTO tblNotes (Title, Note) VALUES (\"%s\", \"%s\")""" % (fstLine, strNote))
                    nNoteId = query.lastInsertId().toInt()
                    print "note id: '%s'" % nNoteId[0]
                else:
                    bRet = True
                    nNoteId = self.lstDataItems.currentItem().data(Qt.UserRole).toInt()
                    #nNoteId = self.editor.data(Qt.UserRole).toInt()
                    bRet = query.exec_("""update tblNotes set Title = \"%s\", Note = \"%s\" where rowid = '%s'""" % (fstLine, strNote, nNoteId[0]))
                    #print "update tblNotes set Title = '%s', Note = \"%s\" where id = '%s'" % (fstLine, strNote, nNoteId[0])
                    print bRet
                if not bRet:
                    QMessageBox.warning(None, "JNoteBook", QString("Database Error: %1").arg(self.db.lastError().text()))
                    rollback = True
                
                for t in tags:
                    print t.text()
                    nTagId = t.data(Qt.UserRole).toInt()
                    if True == self.bNew:
                        bRet = query.exec_("INSERT INTO tblNoteType (idNote, idTag) VALUES ('%s', '%s')" %(nNoteId[0], nTagId[0]))
                        #print "INSERT INTO tblNoteType (idNote, idTag) VALUES ('%s', '%s')" %(nNoteId[0], nTagId[0])
                        #print nNoteId, nTagId
                    else:
                        print nTagId[0]
                        bRet = query.exec_("select count(*) from tblNoteType where idTag = '%s'" % nTagId[0])
                        query.next()
                        if 0 == query.value(0).toInt()[0]:
                            print "tag NOT found"
                            bRet = query.exec_("INSERT INTO tblNoteType (idNote, idTag) VALUES ('%s', '%s')" %(nNoteId[0], nTagId[0]))
                            print "INSERT INTO tblNoteType (idNote, idTag) VALUES ('%s', '%s')" %(nNoteId[0], nTagId[0])
                        else:
                            print "tag found"
                    if not bRet:
                        QMessageBox.warning(None, "JNoteBook", QString("Database Error: %1").arg(self.db.lastError().text()))
                        rollback = True
                        break 
                 
                if rollback:
                    self.db.rollback()
                else:
                    self.db.commit()
                    print "commiited"
                    self.actSaveNote.setDisabled(True)
                self.bNew = False
                self.bEdit = False
                self.editor.setReadOnly(True)
    
    def StoreTag(self, szTag):
        if self.db.open():
            nId = 0
            query = QSqlQuery()
            bRet = query.exec_("select count(*) from tblTags where tagName = '%s'" % szTag)
            query.next()
            if 0 == query.value(0).toInt()[0]:            
                bRet = query.exec_("INSERT INTO tblTags (tagName) VALUES ('%s')" % szTag)
                if not bRet:
                    QMessageBox.warning(None, "JNoteBook", QString("Database Error: %1").arg(self.db.lastError().text()))
                else:
                    nId = query.lastInsertId().toInt()
            else:
                QMessageBox.warning(None, "JNoteBook", QString("Tag already existing"))
        else:
            QMessageBox.warning(None, "JNoteBook", QString("Database Error: %1").arg(self.db.lastError().text()))
        return nId
      
    def OnAddTag(self):
        print "add tag clicked"
        nRetId = 0
        title = "Tag"
        strTag, ok = QInputDialog.getText(self, title, title)
        if ok and not strTag.isEmpty():
            nRetId = self.StoreTag(strTag)
            print nRetId
            if 0!= nRetId:
                item = QListWidgetItem()
                item.setText(strTag)
                item.setData(Qt.UserRole, QVariant(nRetId[0]))
            
                self.lstTags.insertItem(0, item)
                
    def OnAbout(self):
        print "OnAbout"
        QMessageBox.about(self, "About", "JNoteBook 0.5\n\nNote taking application. Vesion : 0.5 \nCopyright \xa9 2014\n\nJagadees.S\njagadees.wordpress.com\nmsgjsp@gmail.com")
        
    def OnNewFolder(self):
      fldName = self.dlg.textValue()
      print fldName
      indxList = self.tree.selectedIndexes()
      item = self.model.itemFromIndex(indxList[0])
      strPath = item.data().toString()
      
      itmNew = QtGui.QStandardItem(fldName)
      itmNew.setData(strPath+fldName)
      item.appendRow(itmNew)

app = QtGui.QApplication(sys.argv)
if len(sys.argv) > 1:
    #if True == QFile.exists(sys.argv[1]):
    #    DB_NAME = sys.argv[1] + "JNotes.db"
    #    DB_BKP_NAME = sys.argv[1] + ".JNotes.db"
         DB_NAME = sys.argv[1]
         DB_BKP_NAME = sys.argv[1] + ".bkp"
         SRC_PATH = sys.path[0]
else:
    print "db path not found. using default"

main = MainWindow()
main.Setup()
main.Initialize()
#main.show()
main.setWindowTitle("JNoteBook - " + DB_NAME)
main.showMaximized()
sys.exit(app.exec_())

